#define __KERNEL__
/* Saint Jude, Linux Kernel Module.
 * Verion: 0.20
 * 
 * July 28, 2001 
 *
 *
 *    Copyright (C) 2001  Timothy Lalwess (lawless@netdoor.com)
 *
 *    This program is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU General Public License as
 *    published by the Free Software Foundation; either version 2 of
 *    the License, or (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be
 *    useful, but WITHOUT ANY WARRANTY; without even the implied
 *    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *    PURPOSE.  See the GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 *    USA.
 *      
 *
 * 
 */

#include <linux/modversions.h>
#include <linux/sys.h>
#include <linux/sched.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <asm/uaccess.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <asm/segment.h>
#include <asm/unistd.h>
#include <linux/mm.h>
#include <linux/smp.h>
#include <linux/signal.h>
#include <linux/slab.h>
#include <asm/unistd.h>
#include <asm/current.h>
#include <sys/syscall.h>
#include <asm/errno.h>
#include <asm/ptrace.h>
#include <asm/pgtable.h>
#include "StJude_lkm.h"
#include "StJude_string_util.h"


extern SJ_PRIV *sj_priv_hash[SJ_PRIV_HASH];
extern SJ_MEMORY *sj_argv_memory_hash[SJ_MEMORY_HASH];

extern SJ_RULEBASE sj_rulebase[];

/* We are busy! Go away! */
int
sj_delete_module (const char *name)
{
   
#if defined(USE_STMICHAEL) && !defined(LEARNING)
   int delete_module_return;
#endif

#ifdef __SMP__
read_lock(&tasklist_lock);
#endif

#ifdef DEBUG
printk(" -----------------------------SYSCALL BY %d------------------------\n",current->pid);
#endif

#ifdef __SMP__
read_unlock(&tasklist_lock);
#endif

#if defined(USE_STMICHAEL) && !defined(LEARNING)

   if (name != NULL && *name != '\0')
   {
   if ( ! sj_strncmp(name,"StJude", 12) )
      {
         sj_print("(STMICHAEL) Attempt To Remove StMichael Detected.\n");
         return -EBUSY;
      }

   if ( ! sj_strncmp(name,"+",1) )
      {
        sj_print("(STMICHAEL) Checking Name 2.\n");
        sj_print("(STJUDE) Attempt to Remove Protected Module Detected.\n");
        return -EBUSY;
      }
    }

#ifdef ROKMEM
   sj_kemem_rw();
#endif

   delete_module_return = (*orig_delete_module)(name);


#ifdef ROKMEM
   sj_kemem_ro();
#endif

#ifdef FSCHECK
#ifdef __SMP__
   write_lock(&fscheck_lock);
#endif
   check_fscheck_records();
#ifdef __SMP__
   write_unlock(&fscheck_lock);
#endif
#endif


   
  /* 
     Verify that the syscall table is the same. 
     If its changed then respond 

     We could probably make this a function in itself, but
     why spend the extra time making a call?

   */

#ifdef USE_CHECKSUM
   sj_check_dependency_integrity();
#endif

#ifdef CLOAK
   sj_remove_module_list(name);
#endif

   sj_check_sys_call_integrity();

#ifdef CLOAK
   sj_check_module_list();
#endif

  return delete_module_return;
#else

  return -EBUSY;

#endif

}

