#define __KERNEL__
/* Saint Jude, Linux Kernel Module.
 * Verion: 0.20
 * 
 * July 28, 2001 
 *
 *
 *    Copyright (C) 2001  Timothy Lalwess (lawless@netdoor.com)
 *
 *    This program is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU General Public License as
 *    published by the Free Software Foundation; either version 2 of
 *    the License, or (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be
 *    useful, but WITHOUT ANY WARRANTY; without even the implied
 *    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *    PURPOSE.  See the GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 *    USA.
 *      
 *
 * 
 */

#include <linux/modversions.h>
#include <linux/sys.h>
#include <linux/sched.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <asm/uaccess.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <asm/segment.h>
#include <asm/unistd.h>
#include <linux/mm.h>
#include <linux/smp.h>
#include <linux/signal.h>
#include <linux/slab.h>
#include <asm/unistd.h>
#include <asm/current.h>
#include <sys/syscall.h>
#include <asm/errno.h>
#include <asm/ptrace.h>
#include <asm/pgtable.h>
#include <linux/timer.h>
#include "StJude_lkm.h"
#include "StMichael_timer.h"
#include "StJude_string_util.h"

timer_t sj_timer;

void sj_timer_init(void)
{
    sj_memset(&sj_timer,0,sizeof(timer_t));
    init_timer(&sj_timer);
    sj_timer.expires = jiffies + SM_TIMEOUT;
    sj_timer.function = sj_timer_handler;
    add_timer(&sj_timer);
}

void sj_timer_handler(unsigned long arg)
{
    del_timer(&sj_timer);


#ifdef USE_CHECKSUM
   sj_check_dependency_integrity();
#endif

   sj_check_sys_call_integrity();
#ifdef CLOAK
   sj_check_module_list();
#endif


    init_timer(&sj_timer);
    sj_timer.expires = jiffies + SM_TIMEOUT;
    sj_timer.function = sj_timer_handler;
    add_timer(&sj_timer);
}

void sj_timer_remove(void)
{
    del_timer(&sj_timer);
    sj_memset(&sj_timer,0,sizeof(sj_timer));
}
